#include "autosavecondition.h"

autosave_condition::autosave_condition():
condition(0),filename(0),enabled(true),rawvf(true),terminal(false),popup_string(0),enabled_popup(false)
{
}

autosave_condition::~autosave_condition()
{
	if(condition) delete condition;
	if(filename) delete filename;
	if(popup_string) delete popup_string;
}

QString autosave_condition::print()
{
	const QString sep=" | ";
	QString res=name+sep;
	if(condition) res+=condition->print()+" || "; else return "";
	res+=folder+sep;
	if(filename) res+=filename->print()+sep; else res+=sep;
	if(!enabled) res+="off"+sep;
	if(!rawvf) res+="avf"+sep;
	if(terminal) res+="t"+sep;
	if(popup_string) 
	{
		res+="p "+popup_string->print()+sep;
		if(!enabled_popup) res+="off"+sep;
	}
	return res;
}

