#include "autosaveeditor.h"

void autosave_editor::init()
{
	layout=new QGridLayout(this);
	l_name.setParent(this);name.setParent(this);
	l_formula.setParent(this);e_formula.setParent(this);
	l_filename.setParent(this);filename.setParent(this);
	l_folder.setParent(this);folder.setParent(this);
	l_popup.setParent(this);popup.setParent(this);c_popup.setParent(this);
	
	l_name.setText(T->str[ins_label]);
	l_formula.setText(T->str[ins_condition]);
	l_filename.setText(T->str[ins_filename]);
	l_folder.setText(T->str[ins_folder]);
	browsefolder.setText(T->str[ins_browse]);
	l_popup.setText(T->str[ins_popup_msg]);
	apply.setText(T->str[ins_apply]);
	applyfile.setText(T->str[ins_apply]);
	applypopup.setText(T->str[ins_apply]);
	addcond.setText(T->str[ins_add]);
	delcond.setText(T->str[ins_remove]);
	editformula.setText(T->str[ins_open_fe]);
	on.setText(T->str[ins_autosave]);
	c_popup.setText(T->str[ins_popup]);
	ok.setText(T->str[ins_exit]);
	rawvf.setText(T->str[ins_save_as_rawvf]);
	terminal.setText(T->str[ins_terminal]);
	t.insertColumn(0);
	t.insertColumn(1);
	
	layout->addWidget(&t,0,0,1,4);
	layout->addWidget(&addcond,1,0,1,1);
	layout->addWidget(&delcond,1,1,1,1);
	layout->addWidget(&editformula,1,2,1,1);
	layout->addWidget(&l_name,2,0,1,1);
	layout->addWidget(&name,2,1,1,1);
	layout->addWidget(&on,2,2,1,1);
	layout->addWidget(&rawvf,2,3,1,1);
	layout->addWidget(&l_formula,3,0,1,1);
	layout->addWidget(&e_formula,3,1,1,2);
	layout->addWidget(&apply,3,3,1,1);
	layout->addWidget(&l_folder,4,0,1,1);
	layout->addWidget(&folder,4,1,1,2);
	layout->addWidget(&browsefolder,4,3,1,1);
	layout->addWidget(&l_filename,5,0,1,1);
	layout->addWidget(&filename,5,1,1,2);
	layout->addWidget(&applyfile,5,3,1,1);
	layout->addWidget(&terminal,6,0,1,4);
	layout->addWidget(&c_popup,7,0,1,4);
	layout->addWidget(&l_popup,8,0,1,1);
	layout->addWidget(&popup,8,1,1,2);
	layout->addWidget(&applypopup,8,3,1,1);
	layout->addWidget(&ok,9,0,1,4);

	id=row=-1;enable(false);

	connect(&apply,SIGNAL(clicked()),this,SLOT(apply_formula()));
	connect(&addcond,SIGNAL(clicked()),this,SLOT(add()));
	connect(&delcond,SIGNAL(clicked()),this,SLOT(remove()));
	connect(&editformula,SIGNAL(clicked()),this,SLOT(f_editor()));
	connect(&ok,SIGNAL(clicked()),this,SLOT(quit()));
	connect(&browsefolder,SIGNAL(clicked()),this,SLOT(edit_folder()));

	connect(&name,SIGNAL(textEdited(const QString &)),this,SLOT(change_name(const QString&)));
	connect(&folder,SIGNAL(textEdited(const QString &)),this,SLOT(change_folder(const QString&)));
	connect(&applyfile,SIGNAL(clicked()),this,SLOT(apply_file()));
	connect(&applypopup,SIGNAL(clicked()),this,SLOT(apply_popup()));
	connect(&on,SIGNAL(clicked()),this,SLOT(toggle()));
	connect(&c_popup,SIGNAL(clicked()),this,SLOT(toggle_popup()));
	connect(&rawvf,SIGNAL(clicked()),this,SLOT(toggle_rawvf()));
	connect(&terminal,SIGNAL(clicked()),this,SLOT(toggle_terminal()));
	
	connect(&t,SIGNAL(currentCellChanged(int,int,int,int)),this,SLOT(choose(int,int,int,int)));

	setMinimumWidth(400);
}
void autosave_editor::refresh()
{
	int row=0;

	disconnect(&t,SIGNAL(currentCellChanged(int,int,int,int)),this,SLOT(choose(int,int,int,int)));
	t.clear();
	t.setHorizontalHeaderItem(0,new QTableWidgetItem(T->str[ins_label]));
	t.setHorizontalHeaderItem(1,new QTableWidgetItem(T->str[ins_condition]));
	for(int i=0;i<conditions.size();++i)
		if(conditions[i] && conditions[i]->condition)
		{
			QTableWidgetItem* l_n=new QTableWidgetItem();
			QTableWidgetItem* l_f=new QTableWidgetItem();
			l_n->setText(conditions[i]->name);
			l_n->setFlags(l_f->flags() & (~Qt::ItemIsSelectable & ~Qt::ItemIsEditable));
			l_f->setText(conditions[i]->condition->print());
			l_f->setFlags(l_f->flags() & (~Qt::ItemIsSelectable & ~Qt::ItemIsEditable));
			if(t.rowCount()<=row) t.insertRow(row);
			t.setItem(row,0,l_n);
			t.setItem(row++,1,l_f);
		}
	t.setRowCount(row);
	t.resizeColumnsToContents();
	connect(&t,SIGNAL(currentCellChanged(int,int,int,int)),this,SLOT(choose(int,int,int,int)));
}

void autosave_editor::enable(bool on)
{
	name.setEnabled(on);
	e_formula.setEnabled(on);
	editformula.setEnabled(on);
	filename.setEnabled(on && conditions[id]->enabled);
	folder.setEnabled(on && conditions[id]->enabled);
	rawvf.setEnabled(on && conditions[id]->enabled);
	terminal.setEnabled(on && conditions[id]->enabled);
	applypopup.setEnabled(on && conditions[id]->enabled_popup);
	applyfile.setEnabled(on && conditions[id]->enabled);
	apply.setEnabled(on);
	popup.setEnabled(on && conditions[id]->enabled_popup);
	c_popup.setEnabled(on);
	delcond.setEnabled(on);
	browsefolder.setEnabled(on && conditions[id]->enabled);
	this->on.setEnabled(on);
}

int autosave_editor::row_to_id(int _row)
{
	int i;
	for(i=0;i<conditions.size() && _row;++i)
		if(conditions[i] && conditions[i]->condition) --_row;
	for(;i<conditions.size() && (!conditions[i] || !conditions[i]->condition);++i);
	return i;
}

void autosave_editor::choose(int row,int,int,int)
{
	this->row=row;
	id=row_to_id(row);
	if(id>=0 && id<conditions.size())
	{
		enable(true);
		name.setText(conditions[id]->name);
		e_formula.setText(conditions[id]->condition->print());
		folder.setText(conditions[id]->folder);
		filename.setText(conditions[id]->filename->print());
		popup.setText(conditions[id]->popup_string->print());
		on.setChecked(conditions[id]->enabled);
		c_popup.setChecked(conditions[id]->enabled_popup);
		popup.setEnabled(conditions[id]->enabled_popup);
		rawvf.setChecked(conditions[id]->rawvf);
		terminal.setChecked(conditions[id]->terminal);
	}
	else enable(false);
}

void autosave_editor::apply_formula()
{
	formula* f=p->parse_expression(e_formula.text());
	if(f)
	{
		if(conditions[id]->condition) delete conditions[id]->condition;
		conditions[id]->condition=f;
		refresh();
		changed=true;
	}
	choose(row,0,-1,-1);
}
void autosave_editor::change_name(const QString& s)
{
	conditions[id]->name=s;
	conditions[id]->name.remove(QChar('|'));
	refresh();
	changed=true;
}
void autosave_editor::change_folder(const QString& s)
{
	conditions[id]->folder=s;
	conditions[id]->folder.remove(QChar('|'));
	changed=true;
}
void autosave_editor::apply_file()
{
	QString fn=filename.text();
	evaluable_string* s=p->parse_string(fn.remove(QChar('|')));
	if(s)
	{
		if(conditions[id]->filename) delete conditions[id]->filename;
		conditions[id]->filename=s;
		filename.setText(conditions[id]->filename->print());
		changed=true;
	}
}
void autosave_editor::apply_popup()
{
	QString ps=popup.text();
	evaluable_string* s=p->parse_string(ps.remove(QChar('|')));
	if(s)
	{
		if(conditions[id]->popup_string) delete conditions[id]->popup_string;
		conditions[id]->popup_string=s;
		popup.setText(conditions[id]->popup_string->print());
		changed=true;
	}
}
void autosave_editor::toggle()
{
	conditions[id]->enabled=on.isChecked();
	choose(row,0,-1,-1);
	changed=true;
}
void autosave_editor::toggle_popup()
{
	conditions[id]->enabled_popup=c_popup.isChecked();
	popup.setEnabled(conditions[id]->enabled_popup);
	applypopup.setEnabled(conditions[id]->enabled_popup);
	changed=true;
}
void autosave_editor::toggle_rawvf()
{
	conditions[id]->rawvf=rawvf.isChecked();
	changed=true;
}
void autosave_editor::toggle_terminal()
{
	conditions[id]->terminal=terminal.isChecked();
	changed=true;
}
void autosave_editor::edit_folder()
{
	QString res;
	if(( (res=retrieve_folder())!="" ))
	{
		res.remove(QChar('|'));
		conditions[id]->folder=res;
		folder.setText(res);
		change_folder(res);
		changed=true;
	}
}

QString autosave_editor::retrieve_folder()
{
	return QFileDialog::getExistingDirectory(this,T->str[ins_choose_folder],conditions[id]->folder);
}

void autosave_editor::add()
{
	QString n=input(this,T->str[ins_request_cond_name],"");
	if(n=="") return;

	formula_editor fed(fet_expression,T,sk,p);
	fed.get_expression(0);
	if(fed.rese)
	{
		autosave_condition* nc=new autosave_condition;
		evaluable_string *s;
		
		conditions << nc;
		nc->name=n;
		nc->condition=fed.rese;
		nc->folder=retrieve_folder();
		s=p->parse_string(input(this,T->str[ins_request_filename],""));
		if(s) nc->filename=s; else nc->filename=p->parse_string("default_filename");
		nc->popup_string=p->parse_string("");
		nc->enabled_popup=false;
		nc->enabled=true;
		nc->rawvf=true;
		nc->terminal=false;
		refresh();
		changed=true;
	}
}
void autosave_editor::remove()
{
	if(id!=-1 && conditions[id])
	{
		delete conditions[id];conditions[id]=0;
		enable(false);id=row=-1;
		refresh();
		changed=true;
	}
}
void autosave_editor::f_editor()
{
	formula_editor fed(fet_expression,T,sk,p);
	fed.get_expression(conditions[id]->condition);
	conditions[id]->condition = fed.rese;
	refresh();
	choose(row,0,-1,-1);
}
void autosave_editor::quit()
{
	for(int i=0;i<conditions.size();++i)
		if(!(QDir(conditions[i]->folder).exists()))
		{
			err(T->str[ins_folder]+" "+QString::number(i)+" ("+conditions[i]->folder+
			") "+T->str[ins_doesnt_exist]+".");
			conditions[i]->folder=p->video_dir;
		}
	hide();
}

autosave_editor::autosave_editor(translation* T,skin* sk,QList<autosave_condition*>& v,parser* p,bool& changed):
T(T),sk(sk),conditions(v),p(p),changed(changed)
{
	init();
	refresh();
	setWindowTitle(T->str[ins_autosave_editor]);
	setWindowIcon(sk->program_icon);
}

