#include "autosaver.h"

const QString F_autosave="freesweeper.autosave";

autosaver::autosaver(translation* T,skin* sk,parser* Parser,evaluator* Eval):
T(T),sk(sk),autosaves_changed(settings_dir!=normal_settings_dir),Parser(Parser),Eval(Eval)
{
}

void autosaver::load()
{
	QFile f(settings_dir+F_autosave);
	
	if(!f.open(QIODevice::ReadOnly))
	{
		autosaves_changed=true;
		err(T->str[ins_e_open_autosave]);
	}
	else
	{
		while(!f.atEnd())
		{
			QString auto_desc=readln_without_comments(f).trimmed();
			if(auto_desc=="") continue;
			autosave_condition* nc=Parser->parse_autosave_condition(auto_desc);
			if(!nc) continue;
			conds << nc;
		}
		f.close();
	}
}

void autosaver::save()
{
	if(!autosaves_changed) return;

	QFile f(settings_dir+F_autosave);

	if(!f.open(QIODevice::WriteOnly | QIODevice::Truncate))
		err(T->str[ins_e_open_autosave]);
	else
	{
		for(QList<autosave_condition*>::iterator i=conds.begin();i!=conds.end();++i)	
			if(*i && (*i)->condition) 
			{
				writeln(f,(*i)->print());
			}
		f.close();
	}
}

void autosaver::apply()
{
	bool not_saved=true;
	popup="";
	Eval->h_date=false;
	for(int i=0;i<conds.size();++i)
		if(Eval->eval_expr(conds[i]->condition))
		{
			cout<<"condition "<<i<<" fired"<<endl;
			if(conds[i]->enabled && not_saved) 
			{
				if(conds[i]->rawvf)
					emit save_rawvf(conds[i]->folder+Eval->eval(conds[i]->filename));
				else
					emit save_secure(conds[i]->folder+Eval->eval(conds[i]->filename));
				not_saved=!conds[i]->terminal;
			}
			if(conds[i]->enabled_popup) popup+=Eval->eval(conds[i]->popup_string);
		}
}

void autosaver::autosave_manager()
{
	autosave_editor AE(T,sk,conds,Parser,autosaves_changed);
	AE.exec();
}

