#ifndef _FS_AUTOSAVER_H
#define _FS_AUTOSAVER_H

#include "freesweeper.h"
#include "autosavecondition.h"
#include "parser.h"
#include "eval.h"
#include "autosaveeditor.h"
#include "translation.h"

class autosaver : public QObject
{
	Q_OBJECT

	translation* T;
	skin* sk;
	QList<autosave_condition*> conds;
	
	bool autosaves_changed;
public:
	parser* Parser;
	evaluator* Eval;
	
	QString popup;
	
	autosaver(translation* T,skin* sk,parser* Parser,evaluator* Eval);
	
	void load();
	void save();
	
	void apply();
	
public slots:
	void autosave_manager();	
	
signals:
	void save_rawvf(QString filename);
	void save_secure(QString filename);
};

#endif

