#include "board.h"

void board::repaint_square(int x,int y,QPixmap* pix)
{
	squares[x][y].p=pix;
	update(QRect((x-cur_scr_x)*sk->square_size,(y-cur_scr_y)*sk->square_size,sk->square_size,sk->square_size));	
}

void board::repaint_arrow(int x,int y)
{
//	for(int i=x;i<=x+1;++i) for(int j=y;j<=y+1;++j) if(is_inside(x,y)) squares[x][y].d=0;
	update(QRect((x/sk->square_size-cur_scr_x)*sk->square_size,
					(y/sk->square_size-cur_scr_y)*sk->square_size,
						sk->square_size*2,sk->square_size*2));
}

void board::push_around(int x,int y)
{	// push the {neighborhood}
	for(int i=x-1;i<=x+1;++i)
		for(int j=y-1;j<=y+1;++j)
			push(i,j);
}
void board::pop_around(int x,int y)
{	// pop the {neighborhood}
	for(int i=x-1;i<=x+1;++i)
		for(int j=y-1;j<=y+1;++j)
			pop(i,j);
}

void board::push(int x,int y)
{
	if(squares[x][y].openable())
	{
		if(squares[x][y].questioned)
		{
			repaint_square(x,y,&sk->question_pr);
			write_board_event(be_pressedqm,x,y);
		}
		else
		{
			repaint_square(x,y,&sk->sq_pr);
			write_board_event(be_pressed,x,y);
		}
	}
}
void board::pop(int x,int y)
{
	if(squares[x][y].openable())
	{
		if(squares[x][y].questioned)
		{
			repaint_square(x,y,&sk->question);
			write_board_event(be_qm,x,y);
		}
		else
		{
			if(D.state>=playing_video && v_show_board)
			{
				if(!squares[x][y].mine)
					repaint_square(x,y,&sk->numberpop[squares[x][y].num]);
				else
					repaint_square(x,y,&sk->minepop);
			}
			else
				repaint_square(x,y,&sk->sq);
			write_board_event(be_closed,x,y);
		}
	}
}
void board::show_question(int x,int y)
{
	repaint_square(x,y,&sk->question);
	squares[x][y].questioned=true;
	write_board_event(be_qm,x,y);
}
void board::show(int x,int y)
{
	int num=squares[x][y].num;
	repaint_square(x,y,&sk->number[num]);
	write_board_event(be_num0+num,x,y);
	squares[x][y].opened=true;

	if(num)
	{
		++D.shown_numbers[num];
		++D.shown_numbers[0];
	}
	++D.open_squares;
	--D.size_op[squares[x][y].opening];
	--D.size_op[squares[x][y].opening2];
}
void board::show_after_end(int x,int y)
{
	if(squares[x][y].type) return;
	if(!squares[x][y].mine)
		squares[x][y].p=&sk->numberpop[squares[x][y].num];
	else
		squares[x][y].p=&sk->minepop;
}

void board::flag(int x,int y)
{
	repaint_square(x,y,&sk->flag);
	squares[x][y].flagged=squares[x][y].wasted_flag=true;
	write_board_event(be_flag,x,y);
}
void board::unflag(int x,int y)
{
	repaint_square(x,y,&sk->sq);
	squares[x][y].flagged=squares[x][y].questioned=false;
	write_board_event(be_closed,x,y);
}
void board::show_wasted_flag(int x,int y)
{
	repaint_square(x,y,&sk->flag_wasted);
}
void board::show_mine(int x,int y)
{
	repaint_square(x,y,&sk->mine);
	squares[x][y].opened=true;
}
void board::show_blast(int x,int y)
{
	repaint_square(x,y,&sk->blasted_mine);
	squares[x][y].opened=true;
	++D.open_squares;++D.open_mines;
	write_board_event(be_blast,x,y);
}
void board::show_misflag(int x,int y)
{
	repaint_square(x,y,&sk->flag_false);
	squares[x][y].opened=true;
}

