#include "board.h"

int board::zn_3bv_around(int x,int y)
{
	int res=0,op=-1;
	for(int i=x-1;i<=x+1;++i)	// how many 3bv are in the {neighborhood}
		for(int j=y-1;j<=y+1;++j)
			if(!squares[i][j].mine && !squares[i][j].opening && !squares[i][j].type)
				++res;
			else if(squares[i][j].opening && !squares[i][j].num && squares[i][j].opening!=op)
			{
				op=squares[i][j].opening;
				++res;
			}
	return res;
}

void board::zn_open(int x,int y)
{
	squares[x][y].zn_opened=true;
	++squares[x][y].premium;
	if(!squares[x][y].opening) // non-opening 3bv
		for(int i=x-1;i<=x+1;++i)
			for(int j=y-1;j<=y+1;++j)
				--squares[i][j].premium; // reduce the premia of squares in the {neighborhood}
	--zn_closed;
}

void board::zn_reveal(int x,int y)
{
	if(squares[x][y].zn_opened || squares[x][y].type) return;

	if(squares[x][y].num)
		zn_open(x,y);
	else /* damn it's an opening!!! */
	{
		int op=squares[x][y].opening;
		for(int i=1;i<=D.width;++i)
			for(int j=1;j<=D.height;++j)
				if(squares[i][j].opening==op || squares[i][j].opening2==op)
				{
					if (!squares[i][j].zn_opened) zn_open(i,j);
					--squares[i][j].premium;
				}
	}
}
void board::zn_click(int& zini,int x,int y)
{
	++zini;
	zn_reveal(x,y);
}
void board::zn_flag(int& zini,int x,int y)
{
	if(squares[x][y].zn_opened) return;
	++zini;
	squares[x][y].zn_opened=true;
	for(int i=x-1;i<=x+1;++i)	// increase the premia of the squares in the {neighborhood}
		for(int j=y-1;j<=y+1;++j)
			++squares[i][j].premium;
}
void board::zn_flag_around(int& zini,int x,int y)
{
	for(int i=x-1;i<=x+1;++i)	// flag the {neighborhood}
		for(int j=y-1;j<=y+1;++j)
			if(squares[i][j].mine) zn_flag(zini,i,j);
}
void board::zn_chord(int& zini,int x,int y)
{
	++zini;
	for(int i=x-1;i<=x+1;++i)	// reveal the {neighborhood}
		for(int j=y-1;j<=y+1;++j)
			zn_reveal(i,j);
}
void board::zn_hit_openings(int& zini)
{
	for(int i=1;i<=D.width;++i)
		for(int j=1;j<=D.height;++j)
			if(!squares[i][j].num && !squares[i][j].zn_opened && !squares[i][j].mine)
				zn_click(zini,i,j);
}

void board::zini_step(int& zini,bool human)
{
	int maxp=-1;
	int curi=-1,curj=-1;
	for(int i=1;i<=D.width;++i)
		for(int j=1;j<=D.height;++j)
		{
			if(!squares[i][j].mine &&
			(squares[i][j].zn_opened || !human) &&
			squares[i][j].premium>maxp)
			{
				maxp=squares[i][j].premium;
				curi=i;curj=j;
			}
		}
	if(curi!=-1) // there's a non-negative premium, click-flag-chord
	{
		if(!squares[curi][curj].zn_opened) zn_click(zini,curi,curj);
		zn_flag_around(zini,curi,curj);
		zn_chord(zini,curi,curj);
	}
	else // else click
	{
		for(int i=1;i<=D.width && curi==-1;++i)
			for(int j=1;j<=D.height;++j)
			{
				if(!squares[i][j].zn_opened && !squares[i][j].mine &&
					(!squares[i][j].num || !squares[i][j].opening))
				{
					curi=i;curj=j;
					break;
				}
			}
		zn_click(zini,curi,curj);
	}
}

int board::get_zini(bool human)
{	// it supposes the numbers and the openings are already initialized
	int zini=0;
	zn_closed=size;
	for(int i=1;i<=D.width;++i)
		for(int j=1;j<=D.height;++j)
		{
			squares[i][j].zn_opened=0;
			squares[i][j].premium=zn_3bv_around(i,j)-squares[i][j].num-2;
			if(squares[i][j].mine) --zn_closed;
		}
	if(human) zn_hit_openings(zini);
	for(int i=0;zn_closed && i<size;++i)	// for instead of while, because we don't want freezings due to errors
		zini_step(zini,human);
	return zini;
}

