#ifndef _FS_COUNTER_H
#define _FS_COUNTER_H

#include "freesweeper.h"
#include "skin.h"
#include "evaluable.h"
#include "record.h"
#include "settings.h"

class counter : public QWidget
{
	Q_OBJECT
public:
	skin* sk;

	c_formula* formula;
	
	QLabel name;
	QLabel value;
	QAction menu;
	int type;	// type determines which menu does counter's action belongs to

	int row,column;

	bool bold;
	bool bold_lower;
	double bold_value;
	
	record* rec;

	counter();
	~counter();

	void refresh(QString value);
	void check_boldness(double value,bool has_value);
	
	void initialize(QWidget* parent, skin* skin);

	QString get_name();
	QString get_menu();
	void set_name(const QString& name);
	void set_menu(const QString& menu);
	
	QString print();
	
	void load_records(settings* s);
	void save_records(settings* s);
	void reset_records();

	virtual void showEvent(QShowEvent*);
	virtual void hideEvent(QHideEvent*);
};

#endif
