#ifndef _FS_COUNTERS_EDITOR_H
#define _FS_COUNTERS_EDITOR_H

#include "freesweeper.h"
#include "counter.h"
#include "parser.h"
#include "formulaeditor.h"

class counters_editor : public QDialog
{
	Q_OBJECT

	translation* T;
	skin* sk;
	QList<counter*>& counters;
	parser* p;
	bool& changed;
	bool e_st;
	
	QGridLayout* layout;
	
	int id,ctr;	// current counter
	void init();

	QTableWidget t;
	QLabel l_name;
	QLineEdit name;
	QLabel l_formula;
	QLineEdit formula;
	QLabel l_precision;
	QSpinBox precision;
	QPushButton addctr;
	QPushButton delctr;
	QPushButton editformula;
	QPushButton apply;
	QPushButton ok;

	QCheckBox rec;
	QLabel l_rectype;
	QComboBox rectype;
	QCheckBox recpopup;

public:
	counters_editor(translation* T,skin* sk,QList<counter*>& counters,parser* p,bool& changed,bool e_st);

	void enable(bool on);
	void refresh();

	int id_to_ctr(int id);	// manager's id -> counter id

public slots:
	void quit();

	void choose(int row,int column,int prev_row,int prev_column);

	void add();
	void remove();

	void apply_formula();
	void f_editor();
	
	void change_name(const QString& n);
	void change_precision(int p);

	void change_record();
	void change_record_type(int ind);
	void change_record_popup();
signals:
	void add_counter();
	void delete_counter(int id);
};

#endif

