#ifndef _FS_CUSTOM_MARATHON_EDITOR_H
#define _FS_CUSTOM_MARATHON_EDITOR_H

#include "freesweeper.h"
#include "translation.h"
#include "skin.h"

class custom_marathon_editor : public QDialog
{
	Q_OBJECT
	QGridLayout* layout;
	QListWidget levels;
	QSpinBox width;
	QLabel l_width;
	QSpinBox height;
	QLabel l_height;
	QSpinBox mines;
	QLabel l_mines;
	QPushButton ok;
	QPushButton cancel;
	QPushButton up;
	QPushButton down;
	QPushButton add;
	QPushButton del;
	
	QPushButton beg,intr,exp;
	
public:
	translation* T;
	skin* sk;
		
	int cur;
	QList<board_description>* desc;
	QList<board_description> edited;
	
	custom_marathon_editor(translation* T,skin* sk,QList<board_description>* current);
	
	void make_list();
	
public slots:
	void adjust_mines(int);
	
	void set_beg();
	void set_int();
	void set_exp();
	
	void add_board();
	void del_board();
	
	void cancelled();
	void applied();
	
	void row_changed(int row);
	
	void go_up();
	void go_down();
};


#endif

