#ifndef _FS_EVAL_H
#define _FS_EVAL_H

#include "freesweeper.h"
#include "board-data.h"
#include "evaluable.h"

class history;

struct exceval
{
	exceval(){}
};

class evaluator
{
public:
	board_data* Board;
	const gamemode* mode;
	history* History;
	
	double time,est,bbbvs;
	double cl,wcl,nwcl;
	
	bool h_date,hist_request;
	int year,month,day,hour,minute,second;	// for history processor
	
	bool has_last_value;
	double last_value;
	
	evaluator(board_data* Board,const gamemode* mode);

	QString eval(c_formula* cf);
	QString eval(evaluable_string* s);
	QString eval_special_cf(c_formula_type cft);
	double eval(formula* f);
	bool eval_expr(formula* ex);

	bool show_stats;	// during play
	bool allow_stats;	// 
	bool throw_anyway;	//

	void refresh(int _time);
	
	QDateTime get_date();
};

#endif

