#ifndef _FS_FREESWEEPER_H
#define _FS_FREESWEEPER_H

#include <QtGui>
#include <QWidget>

extern QString settings_dir;
extern QString normal_settings_dir;
extern QString programs_dir;
extern char slash;
extern QTextStream cout;

extern const int release_id;

const int n_modes=6;
const int n_enabled_modes=2;
const int n_stand_levels=3;
const int n_levels=5;
const int n_game_levels=10;

const int min_width=1;
const int min_height=1;

enum gamemode
{
	classic=0,
	lucky=1,
	density=2,
	upk=3,
	cheat=4,
	edit=5
};

enum boardstate
{
	before_game=0,
	playing,	// a board does not react to clicks iff its state>playing
	generating,
	win,
	fail,
	playing_video,	// a board does not write video events iff its state>=playing_video
	stopped_video,
};

enum levelname
{
	l_no_level=0,
	l_beginner=1,l_intermediate=2,l_expert=3,l_megaexpert=4,l_custom=5,
	l_m_beginner=6,l_m_intermediate=7,l_m_expert=8,l_m_time_trial=9,l_m_custom=10
};

// custom size is stored elsewhere
const int level_width[n_levels]= {0,8,16,30,30};
const int level_height[n_levels]={0,8,16,16,24};
const int level_mines[n_levels]={0,10,40,99,200};

struct board_description
{
	int width,height,mines;
	board_description(int w=level_width[l_beginner],
				int h=level_height[l_beginner],
				int m=level_mines[l_beginner]):width(w),height(h),mines(m){}
};


void msg(const QString& s);
void err(const QString& s);
void crit_err(const QString& s);
bool ask(const QString& s);
QString input(QWidget* parent,const QString& query,const QString& def);
int input_int(QWidget* parent,const QString& query,int def,int min,int max);
void writeln(QFile& f, const QString& s);
QString readln(QFile& f);
QString readln_without_comments(QFile& f);

int test();

#endif

