#include "hiscoreswindow.h"

hiscores_window::hiscores_window(translation* T,skin* sk):gr(this),T(T)
{
	wlayout=new QGridLayout(this);
	layout=new QGridLayout(&gr);

	wlayout->addWidget(&gr,0,0,1,4);
	for(int i=0;i<n_stand_levels;++i)
	{
		l[i].setParent(&gr);
		hs[i].setParent(&gr);
		n[i].setParent(&gr);

		layout->addWidget(&(l[i]),i,0,1,1);
		layout->addWidget(&(hs[i]),i,1,1,1);
		layout->addWidget(&(n[i]),i,2,1,1);
	}
	b_ok.setText(T->str[ins_ok]);
	b_ok.setParent(this);
	b_reset.setText(T->str[ins_reset]);
	b_reset.setParent(this);

	wlayout->addWidget(&b_ok,1,3,1,1);
	wlayout->addWidget(&b_reset,1,2,1,1);

	connect(&b_ok,SIGNAL(clicked()),this,SLOT(accept()));
	connect(&b_reset,SIGNAL(clicked()),this,SLOT(reset()));

	// disable resizing
	Qt::WindowFlags f=windowFlags();
	f|=Qt::MSWindowsFixedSizeDialogHint;
	f|=Qt::WindowStaysOnTopHint;
	setWindowFlags(f);

	setWindowTitle(T->str[ins_High_scores]);
	setWindowIcon(sk->program_icon);
	setWindowModality(Qt::ApplicationModal);
}

void hiscores_window::showEvent(QShowEvent*)
{
	resize(gr.width(),gr.height());
}

void hiscores_window::reset()
{
	if(ask(T->str[ins_sure]))
	{
		emit reset_hiscores();
		for(int i=0;i<n_stand_levels;++i)
		{
			hs[i].setNum(999.99);
			n[i].setText(T->str[ins_anon]);
		}
	}

}

hiscores_window::~hiscores_window()
{
	disconnect(&b_ok,SIGNAL(clicked()),this,SLOT(accept()));
	disconnect(&b_reset,SIGNAL(clicked()),this,SLOT(reset()));
}

