#include "optionswindow.h"

options_window::options_window(translation* T,skin* sk)
{
	opt=new QGridLayout(this);
	opt->setSpacing(0);
	opt->setMargin(0);

	modes=new QHBoxLayout(&g_modes);
	modes->setSpacing(0);
	modes->setMargin(0);
	levels=new QHBoxLayout(&g_levels);
	levels->setSpacing(0);
	levels->setMargin(0);

	classicopt=new QGridLayout(&g_classic);
	classicopt->setSpacing(0);
	classicopt->setMargin(0);
	boardclearopt=new QHBoxLayout(0);
	boardclearopt->setSpacing(0);
	boardclearopt->setMargin(0);
	countersopt=new QHBoxLayout(&g_counters);
	countersopt->setSpacing(0);
	countersopt->setMargin(0);
	countersopt1=new QVBoxLayout(&g_counters1);
	countersopt1->setSpacing(0);
	countersopt1->setMargin(0);
	countersopt2=new QVBoxLayout(&g_counters2);
	countersopt2->setSpacing(0);
	countersopt2->setMargin(0);
	wheelopt=new QHBoxLayout(&g_wheel);
	wheelopt->setSpacing(0);
	wheelopt->setMargin(0);
	timelimitopt=new QHBoxLayout(0);
	timelimitopt->setSpacing(0);
	timelimitopt->setMargin(0);
	timebeepopt=new QHBoxLayout(0);
	timebeepopt->setSpacing(0);
	timebeepopt->setMargin(0);

	luckopt=new QHBoxLayout(&g_luck);
	luckopt->setSpacing(0);
	luckopt->setMargin(0);

	densopt=new QHBoxLayout(&g_density);
	densopt->setSpacing(0);
	densopt->setMargin(0);

	cheatopt=new QGridLayout(&g_cheat);
	cheatopt->setSpacing(0);
	cheatopt->setMargin(0);
	restbbbvopt=new QGridLayout(&g_restrictBBBV);
	restbbbvopt->setSpacing(0);
	restbbbvopt->setMargin(0);
	restziniopt=new QGridLayout(&g_restrictZiNi);
	restbbbvopt->setSpacing(0);
	restbbbvopt->setMargin(0);
	resthziniopt=new QGridLayout(&g_restrictHZiNi);
	restbbbvopt->setSpacing(0);
	restbbbvopt->setMargin(0);
	continuesopt=new QVBoxLayout(&g_continues);
	continuesopt->setSpacing(0);
	continuesopt->setMargin(0);
	severalcontinuesopt=new QHBoxLayout(0);
	severalcontinuesopt->setSpacing(0);
	severalcontinuesopt->setMargin(0);

	opt->addWidget(&g_modes,0,0,1,2);
	opt->addWidget(&g_levels,1,0,1,2);
	opt->addWidget(&g_classic,2,0,5,1);
	opt->addWidget(&g_luck,2,1,1,1);
	opt->addWidget(&g_density,3,1,1,1);
	opt->addWidget(&g_cheat,4,1,1,1);
	opt->addWidget(&bCancel,5,1,1,1);
	opt->addWidget(&bOk,6,1,1,1);

	for(int i=0;i<n_modes;++i) modes->addWidget(&mode[i]);
	for(int i=0;i<n_levels;++i) levels->addWidget(&level[i]);
	classicopt->addWidget(&viennaTimer,0,0,1,1);
	classicopt->addWidget(&flagMines,2,0,1,1);
	classicopt->addWidget(&revealSquares,1,0,1,1);
	classicopt->addWidget(&voidRedMines,3,0,1,1);
	classicopt->addWidget(&questionMarks,4,0,1,1);
	classicopt->addWidget(&wideSmiley,5,0,1,2);
	classicopt->addLayout(boardclearopt,6,0,1,2);
	classicopt->addWidget(&hideTimer,0,1,1,1);
	classicopt->addWidget(&forceNF,1,1,1,1);
	classicopt->addWidget(&alwaysAtTop,2,1,1,1);
	classicopt->addWidget(&markWastedFlags,3,1,1,1);
	classicopt->addWidget(&g_counters,7,0,1,2);
	classicopt->addWidget(&g_wheel,8,0,1,2);
	classicopt->addWidget(&restartByTimeLimit,9,0,1,2);
	classicopt->addLayout(timelimitopt,10,0,1,2);
	classicopt->addWidget(&beepByTime,11,0,1,2);
	classicopt->addLayout(timebeepopt,12,0,1,2);
	boardclearopt->addWidget(&boardClearance);
	boardclearopt->addWidget(&boardClearancePercent);
	boardclearopt->addWidget(&l_boardClearance);
	countersopt->addWidget(&g_counters1);
	countersopt1->addWidget(&hideCounters);
	countersopt1->addWidget(&showCountersAfterEnd);
	countersopt1->addWidget(&showCounters);
	countersopt->addWidget(&g_counters2);
	countersopt2->addWidget(&onMainWindow);
	countersopt2->addWidget(&separated);
	wheelopt->addWidget(&f2Wheel);
	wheelopt->addWidget(&chordWheel);
	timelimitopt->addWidget(&l_begTimeLimit);
	timelimitopt->addWidget(&begTimeLimit);
	timelimitopt->addWidget(&l_intTimeLimit);
	timelimitopt->addWidget(&intTimeLimit);
	timelimitopt->addWidget(&l_expTimeLimit);
	timelimitopt->addWidget(&expTimeLimit);
	timebeepopt->addWidget(&l_begTimeBeep);
	timebeepopt->addWidget(&begTimeBeep);
	timebeepopt->addWidget(&l_intTimeBeep);
	timebeepopt->addWidget(&intTimeBeep);
	timebeepopt->addWidget(&l_expTimeBeep);
	timebeepopt->addWidget(&expTimeBeep);

	luckopt->addWidget(&luckLibrary);
	luckopt->addWidget(&luckSolver);

	densopt->addWidget(&l_customWidth);
	densopt->addWidget(&customWidth);
	densopt->addWidget(&l_customHeight);
	densopt->addWidget(&customHeight);
	densopt->addWidget(&l_customMines);
	densopt->addWidget(&customMines);
	
	cheatopt->addWidget(&g_restrictBBBV,0,0,1,1);
	cheatopt->addWidget(&g_restrictZiNi,0,1,1,1);
	cheatopt->addWidget(&g_restrictHZiNi,1,0,1,1);
	cheatopt->addWidget(&g_continues,1,1,1,1);
	cheatopt->addWidget(&sevenOnBoard,2,0,1,1);
	cheatopt->addWidget(&eightOnBoard,2,1,1,1);
	cheatopt->addWidget(&l_iterationsForBoard,3,0,1,1);
	cheatopt->addWidget(&iterationsForBoard,3,1,1,1);
	cheatopt->addWidget(&showProbabilities,4,1,1,1);
	cheatopt->addWidget(&showBoard,4,0,1,1);
	cheatopt->addWidget(&lawnmower,5,0,1,1);
	cheatopt->addWidget(&autoFlag,5,1,1,1);
	cheatopt->addWidget(&elmarTechnique,6,0,1,1);
	cheatopt->addWidget(&nonoMouse,6,1,1,1);
	cheatopt->addWidget(&superFlag,7,0,1,1);
	cheatopt->addWidget(&superClick,7,1,1,1);

	restbbbvopt->addWidget(&l_minimumBBBV,0,0,1,1);
	restbbbvopt->addWidget(&minimumBBBV,0,1,1,1);
	restbbbvopt->addWidget(&l_maximumBBBV,1,0,1,1);
	restbbbvopt->addWidget(&maximumBBBV,1,1,1,1);
	restziniopt->addWidget(&l_minimumZiNi,0,0,1,1);
	restziniopt->addWidget(&minimumZiNi,0,1,1,1);
	restziniopt->addWidget(&l_maximumZiNi,1,0,1,1);
	restziniopt->addWidget(&maximumZiNi,1,1,1,1);
	resthziniopt->addWidget(&l_minimumHZiNi,0,0,1,1);
	resthziniopt->addWidget(&minimumHZiNi,0,1,1,1);
	resthziniopt->addWidget(&l_maximumHZiNi,1,0,1,1);
	resthziniopt->addWidget(&maximumHZiNi,1,1,1,1);
	continuesopt->addWidget(&noContinues);
	continuesopt->addLayout(severalcontinuesopt);
	continuesopt->addWidget(&infiniteContinues);
	severalcontinuesopt->addWidget(&severalContinues);
	severalcontinuesopt->addWidget(&continuesNumber);


	g_modes.setTitle(T->str[ins_mode]);
	QString modes_names[n_modes]={T->str[ins_classic],
		T->str[ins_luck],T->str[ins_dens],T->str[ins_upk],T->str[ins_cheat],T->str[ins_edit]};
	for(int i=0;i<n_modes;++i) mode[i].setText(modes_names[i]);
	
	g_levels.setTitle(T->str[ins_level]);
	QString levels_names[n_levels]={T->str[ins_beg],T->str[ins_int],T->str[ins_exp],T->str[ins_mega],
		T->str[ins_cus]};
	for(int i=0;i<n_levels;++i) level[i].setText(levels_names[i]);

	g_classic.setTitle(T->str[ins_classic_opts]);
	viennaTimer.setText(T->str[ins_tenth_timer]);
	revealSquares.setText(T->str[ins_reveal_after_end]);
	flagMines.setText(T->str[ins_flag_after_end]);
	voidRedMines.setText(T->str[ins_null_after_end]);
	questionMarks.setText(T->str[ins_qmarks]);
	wideSmiley.setText(T->str[ins_wide_smiley]);
	boardClearance.setText(T->str[ins_clear_board]);
	boardClearancePercent.setRange(0,100);
	boardClearancePercent.setAccelerated(true);
	l_boardClearance.setText(T->str[ins_perc_compl]);
	hideTimer.setText(T->str[ins_hide_timer]);
	forceNF.setText(T->str[ins_force_nf]);
	alwaysAtTop.setText(T->str[ins_at_top]);
	markWastedFlags.setText(T->str[ins_mark_wasted]);
	g_counters.setTitle(T->str[ins_counters]);
	hideCounters.setText(T->str[ins_dont_show]);
	showCountersAfterEnd.setText(T->str[ins_hide_until_end]);
	showCounters.setText(T->str[ins_show_stats]);
	onMainWindow.setText(T->str[ins_docked]);
	separated.setText(T->str[ins_separated]);
	g_wheel.setTitle(T->str[ins_wheel]);
	f2Wheel.setText(T->str[ins_new_game]);
	chordWheel.setText(T->str[ins_chord]);

	restartByTimeLimit.setText(T->str[ins_restart_by_limit]);
	l_begTimeLimit.setText(T->str[ins_beg]);
	l_intTimeLimit.setText(T->str[ins_int]);
	l_expTimeLimit.setText(T->str[ins_exp]);

	beepByTime.setText(T->str[ins_beep_by_limit]);
	l_begTimeBeep.setText(T->str[ins_beg]);
	l_intTimeBeep.setText(T->str[ins_int]);
	l_expTimeBeep.setText(T->str[ins_exp]);

	g_luck.setTitle(T->str[ins_luck_opts]);
	luckLibrary.setText(T->str[ins_luck_lib]);
	luckSolver.setText(T->str[ins_luck_solv]);

	g_density.setTitle(T->str[ins_dens_opts]);
	customWidth.setMinimum(1);
	customHeight.setMinimum(1);
	l_customWidth.setText(T->str[ins_cus_width]);
	l_customHeight.setText(T->str[ins_cus_height]);
	l_customMines.setText(T->str[ins_cus_mines]);

	g_cheat.setTitle(T->str[ins_cheat_opts]);
	g_restrictBBBV.setTitle(T->str[ins_restrict_3bv]);
	g_restrictBBBV.setCheckable(true);
	l_minimumBBBV.setText(T->str[ins_min_3bv]);
	l_maximumBBBV.setText(T->str[ins_max_3bv]);
	g_restrictZiNi.setTitle(T->str[ins_restrict_zini]);
	g_restrictZiNi.setCheckable(true);
	l_minimumZiNi.setText(T->str[ins_min_zini]);
	l_maximumZiNi.setText(T->str[ins_max_zini]);
	g_restrictHZiNi.setTitle(T->str[ins_restrict_hzini]);
	g_restrictHZiNi.setCheckable(true);
	l_minimumHZiNi.setText(T->str[ins_min_hzini]);
	l_maximumHZiNi.setText(T->str[ins_max_hzini]);
	sevenOnBoard.setText(T->str[ins_seven_on_board]);
	eightOnBoard.setText(T->str[ins_eight_on_board]);
	l_iterationsForBoard.setText(T->str[ins_generation_iterations]);
	g_continues.setTitle(T->str[ins_lives]);
	noContinues.setText(T->str[ins_none]);
	severalContinues.setText(T->str[ins_several]);
	infiniteContinues.setText(T->str[ins_infinite]);
	showBoard.setText(T->str[ins_show_board]);
	showProbabilities.setText(T->str[ins_show_prob]);
	autoFlag.setText(T->str[ins_autoflag]);
	lawnmower.setText(T->str[ins_lawnmower]);
	elmarTechnique.setText(T->str[ins_elmart]);
	nonoMouse.setText(T->str[ins_nonomouse]);
	superClick.setText(T->str[ins_superclick]);
	superFlag.setText(T->str[ins_superflag]);

	bOk.setText(T->str[ins_ok]);
	bCancel.setText(T->str[ins_cancel]);
	
	// disable resizing
	Qt::WindowFlags f=windowFlags();
	f|=Qt::MSWindowsFixedSizeDialogHint;
	setWindowFlags(f);

	setWindowTitle(T->str[ins_options]);
	setWindowIcon(sk->program_icon);
	setWindowModality(Qt::ApplicationModal);

	minimumBBBV.setRange(0,9999);
	maximumBBBV.setRange(0,9999);
	minimumZiNi.setRange(0,9999);
	maximumZiNi.setRange(0,9999);
	minimumHZiNi.setRange(0,9999);
	maximumHZiNi.setRange(0,9999);
	iterationsForBoard.setRange(1,1000000);
	continuesNumber.setRange(1,1000);
	begTimeLimit.setRange(1,999);
	intTimeLimit.setRange(1,999);
	expTimeLimit.setRange(1,999);
	begTimeBeep.setRange(1,999);
	intTimeBeep.setRange(1,999);
	expTimeBeep.setRange(1,999);
	
	bCancel.setShortcut(Qt::Key_Escape);
	
	for(int i=0;i<n_modes;++i) connect(&mode[i],SIGNAL(clicked()),this,SLOT(mode_changed()));
	connect(&customWidth,SIGNAL(valueChanged(int)),this,SLOT(adjust_custom_mines(int)));
	connect(&customHeight,SIGNAL(valueChanged(int)),this,SLOT(adjust_custom_mines(int)));
	connect(&noContinues,SIGNAL(clicked()),this,SLOT(check_lives()));
	connect(&severalContinues,SIGNAL(clicked()),this,SLOT(check_lives()));
	connect(&infiniteContinues,SIGNAL(clicked()),this,SLOT(check_lives()));
	connect(&boardClearance,SIGNAL(clicked()),this,SLOT(board_clearance()));
	connect(&restartByTimeLimit,SIGNAL(clicked()),this,SLOT(time_limit()));
	connect(&beepByTime,SIGNAL(clicked()),this,SLOT(time_limit()));
	connect(&bOk,SIGNAL(clicked()),this,SLOT(apply()));
	connect(&bCancel,SIGNAL(clicked()),this,SLOT(cancel()));
}

void options_window::mode_changed()
{
	bool m[n_modes];
	for(int i=0;i<n_modes;++i) m[i]=mode[i].isChecked();
	if(m[lucky]) luckLibrary.setChecked(true);
	g_luck.setEnabled(m[lucky] || m[cheat]);
	g_density.setEnabled(m[density] || m[upk] || m[cheat] || m[edit]);
	for(int i=l_expert;i<n_levels;++i) level[i].setEnabled(g_density.isEnabled());
	g_cheat.setEnabled(m[cheat]);
}

void options_window::time_limit()
{
	begTimeLimit.setEnabled(restartByTimeLimit.isChecked());
	intTimeLimit.setEnabled(restartByTimeLimit.isChecked());
	expTimeLimit.setEnabled(restartByTimeLimit.isChecked());
	begTimeBeep.setEnabled(beepByTime.isChecked());
	intTimeBeep.setEnabled(beepByTime.isChecked());
	expTimeBeep.setEnabled(beepByTime.isChecked());
}

void options_window::board_clearance()
{
	boardClearancePercent.setEnabled(boardClearance.isChecked());
}

void options_window::check_lives()
{
	continuesNumber.setEnabled(severalContinues.isChecked());
}

void options_window::adjust_custom_mines(int)
{
	customMines.setRange(0,customWidth.value()*customHeight.value()-1);
}
void options_window::apply()
{
	done(1);
}
void options_window::cancel()
{
	done(0);
}

