#ifndef _FS_OPTIONSWINDOW_H
#define _FS_OPTIONSWINDOW_H

#include "freesweeper.h"
#include "translation.h"
#include "skin.h"

class options_window : public QDialog
{
	Q_OBJECT

	QGridLayout* opt;
	QHBoxLayout* modes;
	QHBoxLayout* levels;
	QGridLayout* classicopt;
	QHBoxLayout* boardclearopt;
	QHBoxLayout* countersopt;
	QVBoxLayout* countersopt1;
	QVBoxLayout* countersopt2;
	QHBoxLayout* wheelopt;
	QHBoxLayout* luckopt;
	QHBoxLayout* densopt;
	QGridLayout* cheatopt;
	QGridLayout* restbbbvopt;
	QGridLayout* restziniopt;
	QGridLayout* resthziniopt;
	QVBoxLayout* continuesopt;
	QHBoxLayout* severalcontinuesopt;
	QHBoxLayout* timelimitopt;
	QHBoxLayout* timebeepopt;
public:
	QGroupBox g_modes;
	QRadioButton mode[n_modes];

	QGroupBox g_levels;
	QRadioButton level[n_levels];
	
	QGroupBox g_classic;
	QCheckBox viennaTimer;
	QCheckBox revealSquares;
	QCheckBox flagMines;
	QCheckBox voidRedMines;
	QCheckBox questionMarks;
	QCheckBox hideTimer;
	QCheckBox forceNF;
	QCheckBox alwaysAtTop;
	QCheckBox markWastedFlags;
	QCheckBox boardClearance;
	QSpinBox boardClearancePercent;
	QLabel l_boardClearance;
	QCheckBox wideSmiley;
	QGroupBox g_counters;
	QGroupBox g_counters1;
	QRadioButton hideCounters;
	QRadioButton showCountersAfterEnd;
	QRadioButton showCounters;
	QGroupBox g_counters2;
	QRadioButton onMainWindow;
	QRadioButton separated;
	QGroupBox g_wheel;
	QRadioButton f2Wheel;
	QRadioButton chordWheel;
	
	QGroupBox g_luck;
	QCheckBox luckLibrary;
	QCheckBox luckSolver;

	QGroupBox g_density;
	QSpinBox customWidth;
	QSpinBox customHeight;
	QSpinBox customMines;
	QLabel l_customWidth;
	QLabel l_customHeight;
	QLabel l_customMines;

	QGroupBox g_cheat;
	QGroupBox g_restrictBBBV;
	QSpinBox minimumBBBV;
	QSpinBox maximumBBBV;
	QGroupBox g_restrictZiNi;
	QSpinBox minimumZiNi;
	QSpinBox maximumZiNi;
	QGroupBox g_restrictHZiNi;
	QSpinBox minimumHZiNi;
	QSpinBox maximumHZiNi;
	QSpinBox iterationsForBoard;
	QLabel l_minimumBBBV;
	QLabel l_maximumBBBV;
	QLabel l_minimumZiNi;
	QLabel l_maximumZiNi;
	QLabel l_minimumHZiNi;
	QLabel l_maximumHZiNi;
	QLabel l_iterationsForBoard;
	QGroupBox g_continues;
	QRadioButton noContinues;
	QRadioButton severalContinues;
	QSpinBox continuesNumber;
	QRadioButton infiniteContinues;
	QCheckBox lawnmower;
	QCheckBox showBoard;
	QCheckBox showProbabilities;
	QCheckBox autoFlag;
	QCheckBox sevenOnBoard;
	QCheckBox eightOnBoard;
	QCheckBox elmarTechnique;
	QCheckBox nonoMouse;
	QCheckBox superClick;
	QCheckBox superFlag;
	
	QCheckBox restartByTimeLimit;
	QLabel l_begTimeLimit;
	QSpinBox begTimeLimit;
	QLabel l_intTimeLimit;
	QSpinBox intTimeLimit;
	QLabel l_expTimeLimit;
	QSpinBox expTimeLimit;
	QCheckBox beepByTime;
	QLabel l_begTimeBeep;
	QSpinBox begTimeBeep;
	QLabel l_intTimeBeep;
	QSpinBox intTimeBeep;
	QLabel l_expTimeBeep;
	QSpinBox expTimeBeep;
	
	QPushButton bOk;
	QPushButton bCancel;
	
	options_window(translation* T,skin* sk);
private slots:
	void adjust_custom_mines(int);
	void apply();
	void cancel();
public slots:
	void mode_changed();
	void time_limit();
	void check_lives();
	void board_clearance();
};

#endif

