#include "square.h"

void square::reset()	// this thing is called after resizing for all squares
{
	d=0;	// nothing drawn yet
	if(!type)
		new_game();
	else
	{
		erase_board_info();
		opened=1;	// board::closed_sq_around() assumes border squares are opened
		num=1;		// needed for board::is_bbbv()
		pmine=0;	// it's unknown whether it is safe
		flagged=0;	// board::flags_around() assumes it's unflagged
	}
}

void square::new_game()
{
	erase_board_info();
	restart();
}
void square::erase_board_info()
{
	mine=num=island=opening=opening2=0;
}
void square::restart()
{
	opened=questioned=false;
	flagged=0;

	psolved=false;
	pmine=0;
}

bool square::openable()
{
	return !type && !opened && !flagged;
}

bool square::flaggable()
{
	return !type && !opened;
}

bool square::unknown()
{
	return !opened && !pmine;
}
bool square::unsolved()
{
	return opened && !psolved && !type;
}

bool square::unopenable()
{
	return mine || type;
}
bool square::unknownsafe()
{
	return !mine && !type && !opened;
}
bool square::unknownmine()
{
	return mine && !type && !opened;
}

