#ifndef _FS_VIDEOCONTROL_H
#define _FS_VIDEOCONTROL_H

#include "freesweeper.h"
#include "skin.h"
#include "clickchart.h"

class videocontrol : public QWidget
{
	Q_OBJECT

	QGridLayout* layout;

	QSlider time;
	QSlider speed;
	QPushButton play;
	QPushButton pause;
	QPushButton stop;
public:
	QCheckBox mousePath;
	QCheckBox revealSquares;
	QCheckBox showOpenings;
	
	int goto_offset;
private:
	QTableWidget events;
	
	clickchart chart;
	
	QLabel lTime;
	QString l_e_time;
	translation* T;
	skin* sk;

	int cur; // last tick
	int video_duration;
	
	bool moving;
	int row;
public:
	videocontrol(translation* T,skin* sk,int end,bool enable_chart,clickevents* ce);
	int get_speed();
	void add_event(int time,int id);
	virtual void closeEvent(QCloseEvent *);
public slots:
	void tick(int tm);
	void time_click();
	void time_move(int pos);
	void time_change();
	void speed_move(int pos);
	void set_normal_speed();
	void speed_right_click(const QPoint&);
	void goto_event(int row, int column);
signals:
	void time_changed(int tm);
	void speed_changed(int sp);
	void stop_video();
	void pause_video();
	void play_video();
	void exit_video();
	
	void toggle_path(bool on);
	void toggle_reveal(bool on);
	void toggle_openings(bool on);	
};

#endif

