#include "chart.h"

chart::chart()
{
}

void chart::reset()
{
	for(int i=0;i<num_pies;++i) num[i]=0;
}

void chart::paintEvent(QPaintEvent*)
{
	int sum=0;
	const int panel=100;
	const int frame_size=50;
	const QColor background(255,255,255);
	const QColor frame(192,192,192);
	const QColor border(0,0,0);
	int w=width()-panel/2;
	int h=height()-panel/2;
	int beg_w=frame_size/2;
	int beg_h=frame_size/3;
	int end_w=width()-frame_size/2;
	int end_h=height()-frame_size/2;
	int h_n=h+frame_size/2-frame_size/3;
	int size=w-panel>h?h-10:w-10-panel;
	const int rect_h_offset=20;
	const int text_h_offset=8;
	const int rect_size=10;
	const int rect_gap=30;
	const int text_v_offset=10;
	int pies[num_pies+1];
	QFont f;
	f.setStyleHint(QFont::SansSerif);
	f.setPointSize(7);	

	QPainter p;
	
	for(int i=0;i<num_pies;++i) sum+=num[i];
	p.begin(this);
	p.fillRect(beg_w,beg_h,w,h_n,QBrush(background));
	p.fillRect(0,0,frame_size/2,height(),QBrush(frame));
	p.fillRect(end_w,0,frame_size/2,height(),QBrush(frame));
	p.fillRect(beg_w,0,width()-frame_size,frame_size/3,QBrush(frame));
	p.fillRect(beg_w,end_h,width()-frame_size,frame_size/2,QBrush(frame));
	if(!sum) return;

	pies[0]=0;
	for(int i=1;i<=num_pies;++i) pies[i]=pies[i-1]+num[i-1];
	for(int i=1;i<=num_pies;++i) pies[i]=(int)((double)pies[i]*5760/sum);

	p.setFont(f);

	p.setPen(border);
	for(int i=0;i<num_pies;++i)
	{
		p.setBrush(color[i]);
		p.drawPie(width()/2-size/2-panel/2, height()/2-size/2, size, size, pies[i], pies[i+1]-pies[i]);
	}
	for(int i=0,j=0;i<num_pies;++i)
	{
		if(!num[i]) continue;
		
		p.setPen(border);
		p.fillRect(width()-rect_h_offset-panel,rect_gap*(j+1),rect_size,rect_size,QBrush(color[i]));
		p.drawText(width()-text_h_offset-panel,rect_gap*(j+1),name[i]);
		p.drawText(width()-text_h_offset-panel,rect_gap*(j+1)+text_v_offset,QString::number(num[i])+"/"+
							QString::number(sum)+" = "+
							QString::number(100.0*num[i]/sum,'f',2)+"%");
		++j;
	}
	
	p.end();
	
}

