#ifndef _FS_H_FORMULAID_H
#define _FS_H_FORMULAID_H

#include "history.h"

enum formula_id
{
	f_none=-1,
	f_int=-2,

	// operators
	f_plus=256,
	f_minus=257,
	f_times=258,
	f_div=259,
	f_power=260,
	f_unary_minus=261,

	f_sqr=262,
	f_log=263,
	f_exp=264,

	//
	f_less=266,
	f_greater=267,
	f_equal=268,
	
	f_or=269,
	f_and=270,
	

	// counters that can be shown while playing
	f_time=0,
	f_path=1,
	f_flags=2,
	f_unflags=3,
	// board properties
	f_mode=4,
	f_level=5,
	f_width=6,
	f_height=7,
	f_mines=8,
	// click rate
	f_l_cl=9,
	f_l_cl_s=10,
	f_r_cl=11,
	f_r_cl_s=12,
	f_d_cl=13,
	f_d_cl_s=14,
	f_cl=15,
	f_cl_s=16,
	f_cl_15=17,
	f_cl_15_s=18,

	// benchmarks
	f_3bv=19,
	f_obv=20,
	f_zini=21,
	f_hzini=22,
	// speed
	f_3bv_s=23,
	f_obv_s=24,
	f_zini_s=25,
	f_hzini_s=26,
	// magic indices	
	f_rqp=27,
	f_ios=28,
	// efficiency
	f_ioe=29,
	f_corr=30,
	f_thrp=31,
	f_zne=32,
	f_znt=33,
	f_hzne=34,
	f_hznt=35,
	//
	f_bat=36,
	// wasted clicks
	f_w_l_cl=37,
	f_w_r_cl=38,
	f_w_d_cl=39,
	f_w_cl=40,
	f_w_cl_15=41,
	// numbers
	f_numbers=42,
	f_ones=43,
	f_twos=44,
	f_threes=45,
	f_fours=46,
	f_fives=47,
	f_sixes=48,
	f_sevens=49,
	f_eights=50,
	// openings and islands
	f_ops=51,
	f_isls=52,
	// mines config
	f_wall_mines=53,
	f_corner_mines=54,
	// flags
	f_misflags=55,
	f_misunflags=56,
	f_wasted_flags=57,
	
	f_total_games=58
};
const int n_named_counters=59;

const QString counter_name[n_named_counters]={"Time","Path","Flags","Unflags",
	"Mode","Level","Width","Height","Mines",
	"LCl","LCl\\s","RCl","RCl\\s","DCl","DCl\\s","Cl","Cl\\s","OneDotFiveCl","OneDotFiveCl\\s",
	"BBBV","OBV","ZiNi","HZiNi",
	"BBBV\\s","OBV\\s","ZiNi\\s","HZiNi\\s",
	"RQP","IOS",
	"IOE","Correctness","ThroughPut","ZNE","ZNT","HZNE","HZNT",
	"BAT",
	"WastedLCl","WastedRCl","WastedDCl","WastedCl","WastedOneDotFiveCl",
	"Numbers","Ones","Twos","Threes","Fours","Fives","Sixes","Sevens","Eights",
	"Openings","Islands",
	"MinesOnWalls","MinesInCorners",
	"Misflags","Misunflags","WastedFlags",
	"TotalGames"
	};

const int n_constants=16;


#endif

