#ifndef _FS_H_HISTORY_H
#define _FS_H_HISTORY_H

#include <QtGui>

#include <iostream>

using std::cout;
using std::endl;
using std::ostream;

extern QString settings_dir;
extern QString programs_dir;
extern char slash;

const int n_stand_levels=3;
const int level_width[n_stand_levels+1]= {0,8,16,30};
const int level_height[n_stand_levels+1]={0,8,16,16};
const int level_mines[n_stand_levels+1]={0,10,40,99};

enum gamemode
{
	classic=0,
	lucky,
	density,
	upk,
	cheat,
	edit
};

enum levelname
{
	nolevel=0,
	l_beginner=1,l_intermediate=2,l_expert=3,l_megaexpert=4,l_custom=5
};

struct gameinfo
{
	int mode,level;
	double time;
	bool flagging;
	int bbbv,zini,hzini;
	double bbbvs,zinis,hzinis;
	int ops,isls;
	int lcl,rcl,dcl,cl15,cl;
	int wlcl,wrcl,wdcl,wcl15,wcl,nwcl;
	int flags,unflags,misflags,misunflags,wflags;
	int distance;
	int mines_in_corners,mines_on_walls;
	int numbers[9];
	
	double obv;
	
	int year,month,day;
	int hour,minute,second;
	int day_of_week;	// 
};

struct density_gameinfo
{
	int level;
	int mines;
	double time;
	bool finished;
	int right_flags;
	
	int year,month,day;
	int hour,minute,second;
};

void msg(const QString& s);
void err(const QString& s);
void crit_err(const QString& s);
bool ask(const QString& s);
QString input(QWidget* parent,const QString& query,const QString& def);
int input_int(QWidget* parent,const QString& query,int def,int min,int max);
ostream& operator<<(ostream& o,const QString& s);
void writeln(QFile& f, const QString& s);
QString readln(QFile& f);
QString readln_without_comments(QFile& f);

#endif

