#ifndef _FS_H_HISTORYWIDGET_H
#define _FS_H_HISTORYWIDGET_H

#include "history.h"
#include "ar.h"
#include "histogram.h"
#include "cloud.h"
#include "chart.h"
#include "translation.h"
#include "parser.h"
#include "eval.h"
#include "settings.h"

class historywidget : public QWidget
{
	Q_OBJECT
	
	histogram hg;
	cloud cl;
	chart ch;

	settings S;
	
	QTabWidget tab;
	QGridLayout layout;
	
	// graphics
	QGroupBox graphs;
	QGridLayout graphs_layout;
	
	QGroupBox graphType;
	QVBoxLayout graphType_layout;
	QRadioButton b_occurence;
	QRadioButton b_cloud;
	QRadioButton b_activity;
	QRadioButton b_styles;
	QRadioButton b_levels;
	
	QGroupBox graphLevel;
	QVBoxLayout graphLevel_layout;
	QCheckBox b_beg;
	QCheckBox b_int;
	QCheckBox b_exp;
	
	QGroupBox xAxis;
	QVBoxLayout xAxis_layout;
	QRadioButton b_x_time;
	QRadioButton b_x_bbbvs;
	QRadioButton b_x_zinis;
	QRadioButton b_x_hzinis;
	QRadioButton b_x_cls;
	QRadioButton b_x_ioe;
	QRadioButton b_x_bbbv;
	QRadioButton b_x_zini;
	QRadioButton b_x_hzini;
	QRadioButton b_x_custom;
	QLineEdit b_x_custom_edit;
	QPushButton b_x_custom_apply;
	
	QGroupBox yAxis;
	QVBoxLayout yAxis_layout;
	QRadioButton b_y_time;
	QRadioButton b_y_bbbvs;
	QRadioButton b_y_zinis;
	QRadioButton b_y_hzinis;
	QRadioButton b_y_cls;
	QRadioButton b_y_ioe;
	QRadioButton b_y_bbbv;
	QRadioButton b_y_zini;
	QRadioButton b_y_hzini;
	QRadioButton b_y_custom;
	QLineEdit b_y_custom_edit;//
	QPushButton b_y_custom_apply;

	QGroupBox isoLines;
	QVBoxLayout isoLines_layout;
	QRadioButton iso_none;
	QRadioButton iso_lines;
	QRadioButton iso_hyperbolas;

	QGroupBox activityType;
	QVBoxLayout activityType_layout;
	QRadioButton activity_hour;
	QRadioButton activity_day;
	QRadioButton activity_month;
	QRadioButton activity_year;
	
	QGroupBox graphSelect;
	QGridLayout graphSelect_layout;
	QCheckBox g_select_f;
	QCheckBox g_select_nf;
	QCheckBox g_select_date;
	QLabel g_date;
	QLineEdit g_date_min;//
	QLineEdit g_date_max;//
	QPushButton g_date_today;
	QPushButton g_date_week;
	QPushButton g_date_month;
	QPushButton g_date_year;
	QPushButton g_date_ar;
	QCheckBox g_select_custom_on;
	QLineEdit g_select_custom_cond;//
	QPushButton g_select_custom_apply;
	
	QGroupBox graphRanges;
	QGridLayout graphRanges_layout;
	QCheckBox xRanges;
	QLabel l_xMin;
	QSpinBox xMin;
	QLabel l_xMax;
	QSpinBox xMax;
	QLabel l_xStep;
	QDoubleSpinBox xStep;
	QCheckBox yRanges;
	QLabel l_yMin;
	QSpinBox yMin;
	QLabel l_yMax;
	QSpinBox yMax;
	QLabel l_yStep;
	QDoubleSpinBox yStep;
	
	// tables
	QGroupBox tables;
	QGridLayout tables_layout;
	
	QGroupBox tableType;
	QVBoxLayout tableType_layout;
	QRadioButton records;
	QRadioButton toplists;
	QRadioButton evolution;
	QRadioButton daily;
	QRadioButton details;
	
	QGroupBox tableLevel;
	QVBoxLayout tableLevel_layout;
	QRadioButton t_beg;
	QRadioButton t_int;
	QRadioButton t_exp;
	
	QGroupBox tableCounter;
	QGridLayout tableCounter_layout;
	QRadioButton tc_time;
	QRadioButton tc_bbbvs;
	QRadioButton tc_zinis;
	QRadioButton tc_hzinis;
	QRadioButton tc_cls;
	QRadioButton tc_ioe;
	QRadioButton tc_bbbv;
	QRadioButton tc_zini;
	QRadioButton tc_hzini;
	QRadioButton tc_custom;
	QLineEdit tc_custom_edit;//
	QPushButton tc_custom_apply;

	QGroupBox tableSelect;
	QGridLayout tableSelect_layout;
	QCheckBox t_select_f;
	QCheckBox t_select_nf;
	QCheckBox t_select_date;
	QLabel t_date;
	QLineEdit t_date_min;//
	QLineEdit t_date_max;//
	QPushButton t_date_today;
	QPushButton t_date_week;
	QPushButton t_date_month;
	QPushButton t_date_year;
	QPushButton t_date_ar;
	QCheckBox t_select_custom_on;
	QLineEdit t_select_custom_cond;//
	QPushButton t_select_custom_apply;
	
	QGroupBox tableRanges;
	QGridLayout tableRanges_layout;
	QLabel l_step;
	QDoubleSpinBox step;

	QGroupBox tableBetter;
	QGridLayout tableBetter_layout;
	QLabel t_l_what_is_better;
	QComboBox t_what_is_better;
	
	QTableWidget table;
	
	// search
	QGroupBox search;
	QGridLayout search_layout;
	
	QGroupBox searchLevel;
	QHBoxLayout searchLevel_layout;
	QRadioButton searchBeg;
	QRadioButton searchInt;
	QRadioButton searchExp;
	QRadioButton searchAll;
	
	QLineEdit searchLine;//
	QPushButton searchApply;
	QTableWidget searchTable;
	
	// IRC
	QGroupBox irc;
	QGridLayout irc_layout;
	
	QLabel l_recs;
	QLineEdit recs;//
	QPushButton b_recs;
	
	QLabel l_avgs;
	QLineEdit avgs;//
	QPushButton b_avgs;
	
	QLabel l_ar;
	QLineEdit ar;//
	QPushButton b_ar;
	
	QLabel l_today;
	QLineEdit today;//
	QPushButton b_today;	
	QRadioButton today_beg;
	QRadioButton today_int;
	QRadioButton today_exp;
	
	// density
	QGroupBox density;
	QGridLayout density_layout;
	
	QGroupBox dens_type;
	QVBoxLayout dens_type_layout;
	QRadioButton dens_finished;
	QRadioButton dens_unfinished;
	
	QGroupBox dens_level;
	QGridLayout dens_level_layout;
	QRadioButton dens_beg;
	QRadioButton dens_int;
	QRadioButton dens_exp;
	QRadioButton dens_mega;
	
	QTableWidget dens_table;
	
	void place_things();
	void connect_things();
	
public:
	QList<gameinfo> h[n_stand_levels];
	
public:	
	historywidget();
	historywidget(int);
	~historywidget();
	
	// reader
	void read_game(QFile& f);
	void read_history();

	// 
	void show_hg();
	void show_cl();
	void show_ch();
	
	bool satisfies_condition(int i);
	bool satisfies_condition(int level,int i);
	bool t_satisfies_condition(int i);
	bool t_satisfies_condition(int level,int i);
	
	virtual void keyPressEvent(QKeyEvent* e);
	virtual void closeEvent(QCloseEvent* e);
	
private:
	translation T;
	parser Parser;
	evaluator Eval;
	formula* f_x;
	formula* f_y;
	formula* cond;
	formula* ind;
	QString cur_ind;
	
	QVector<formula*> table_ctrs;
	QVector<bool> better_is_higher;
	QVector<QString> table_headers;
	QVector<int> table_prec;
	QVector<int> table_avg_prec;
	
	QDateTime d_min,d_max;
	bool d_min_utc,d_max_utc;
	
	// state
	bool levels_cumulative;
	int cur_level;
	bool date_condition_on;
	bool adj_x_axis,adj_y_axis;
	int prec;
	bool cur_better_is_higher;
	
	// analysis parameters
	double a_step;
	bool round_up;
	
	// IRC
	int irc_level,irc_num;
	
	void set_levels_cumulative(bool b);
	
	void fill_occurence();
	void fill_cloud();
	void fill_activity();
	void fill_activity_hour();
	void fill_activity_day();
	void fill_activity_month();
	void fill_activity_year();
	void fill_styles();
	void fill_levels();
	
	void fill_row(int row,int num,double res);
	
	void check_beg();
	void check_int();
	void check_exp();
	
	void redraw_hg();
	void redraw_cl();
	void redraw_ch();

	void steps_from_graph();
	QString date_to_string(QDate d);
	QString date_to_string(int y,int m,int d);
	QString hour_to_string(int h,int m,int s);
	void get_date_from_string(const QString& s,int& y,int& m,int &d);

	bool irc_satisfies_condition(int level,int i,QDateTime d_min,QDateTime d_max,bool utc);
	double irc_getlowest(formula* ind,int level,bool f,bool nf,
					QDateTime beg=QDateTime(),QDateTime end=QDateTime(),bool utc=false);
	double irc_getavg(formula* ind,int level,bool f,bool nf,
					QDateTime beg=QDateTime(),QDateTime end=QDateTime(),bool utc=false);
	double irc_gethighest(formula* ind,int level,bool f,bool nf,
					QDateTime beg=QDateTime(),QDateTime end=QDateTime(),bool utc=false);
							
	void irc_process(QString s);
	
public slots:
	void tab_changed(int);

	void refresh();
	void refresh_graph();
	void refresh_table();
	
	// graphs
	void show_occurence();
	void show_cloud();
	void show_activity();
	void show_styles();
	void show_levels();
	
	void g_beg_chosen();
	void g_int_chosen();
	void g_exp_chosen();
	
	void g_x_time_chosen();
	void g_x_bbbvs_chosen();
	void g_x_zinis_chosen();
	void g_x_hzinis_chosen();
	void g_x_cls_chosen();
	void g_x_ioe_chosen();
	void g_x_bbbv_chosen();
	void g_x_zini_chosen();
	void g_x_hzini_chosen();
	void g_x_custom_chosen();
	
	void g_y_time_chosen();
	void g_y_bbbvs_chosen();
	void g_y_zinis_chosen();
	void g_y_hzinis_chosen();
	void g_y_cls_chosen();
	void g_y_ioe_chosen();
	void g_y_bbbv_chosen();

	void g_y_zini_chosen();
	void g_y_hzini_chosen();
	void g_y_custom_chosen();
	
	void set_date_today();
	void set_date_week();
	void set_date_month();
	void set_date_year();
	void set_date_ar();
	
	void g_init_dates();
	void t_init_dates();
	void set_date_condition();
	void set_date_condition(QString&);
	
	void g_custom_cond();
	void t_custom_cond();
	void g_custom_cond_clicked();
	void t_custom_cond_clicked();
	
	void adj_x_axis_clicked();
	void adj_y_axis_clicked();
	void adjust_x(int);
	void adjust_y(int);
	void adjust_x_step(double);
	void adjust_y_step(double);
	
	void show_records();
	void show_toplists();
	void show_evolution();
	void show_daily();
	void show_details();
	
	void t_beg_chosen();
	void t_int_chosen();
	void t_exp_chosen();
	
	void t_time_chosen();
	void t_bbbvs_chosen();
	void t_zinis_chosen();
	void t_hzinis_chosen();
	void t_cls_chosen();
	void t_ioe_chosen();
	void t_bbbv_chosen();
	void t_zini_chosen();
	void t_hzini_chosen();
	void t_custom_chosen();

	void change_cur_better(int i);
	void change_a_step(double s);
	
	void a_step_changed(double s);
	
	void fill_search_row(int row,int level,int num,int all);
	void makesearch();
	
	void irc_copy_records();
	void irc_copy_averages();
	void irc_copy_ar();
	void irc_copy_today();
	void irc_copy_today(int level);
	
	void show_density();
	void show_density_finished(QFile& f,int level);
	void show_density_unfinished(QFile& f,int level);
};

#endif

